#ifndef COLUMNEDITOR_P_H
#define COLUMNEDITOR_P_H

#include <QDialog>
#include <QMap>

namespace Ui {
class ColumnEditor;
}

class ColumnEditor : public QDialog
{
    Q_OBJECT
public:
    explicit ColumnEditor(QStringList &excludeAttributes, QWidget *parent = nullptr);
    ~ColumnEditor();

    void setAttribute(const QString &attr);
    void setTitle(const QString &title);

    QString attribute() const;
    QString title() const;

private slots:
    void on_titleComboBox_currentIndexChanged(const QString &text);
    void on_attributeComboBox_currentIndexChanged(const QString &text);

private:
    Ui::ColumnEditor *m_ui;
    QMap<QString, QString> m_attributes;
};

#endif // COLUMNEDITOR_P_H
