#ifndef JOURNALVIEWER_H
#define JOURNALVIEWER_H

#include <QDialog>
#include <QVariantMap>
#include <QList>
#include <QPair>
#include "fly-admin-printer-mac_export.h"

class QMenu;

namespace Ui {
class JournalViewer;
}

class FLY_ADMIN_PRINTER_MAC_EXPORT JournalViewer : public QDialog
{
    Q_OBJECT

public:
    explicit JournalViewer(QWidget *parent = nullptr);
    ~JournalViewer();

    void popup();

private slots:
    void reject() override;
    void on_searchButton_clicked();
    void on_fromDateButton_clicked();
    void on_toDateButton_clicked();
    void on_prevPageButton_clicked();
    void on_nextPageButton_clicked();
    void on_savePresetButton_clicked();
    void on_deletePresetButton_clicked();
    void on_presetComboBox_activated(int index);
    void on_printButton_clicked();
    void showAttrs();
    void addColumn();
    void editColumn();
    void removeColumn();

private:
    void findJobs();
    void resetInput();
    void writePresets();
    QMap<QString, QString> getSearchAttributes() const;
    void setSearchAttributes(const QMap<QString, QString> &attributes);
    QString toHtml() const;

    Ui::JournalViewer *m_ui;
    QMap<QString, QString> m_searchAttributes;
    int m_count = 0;
    int m_page = 0, m_pages = 1;
    QList< QPair<QString, QString> > m_columns; //title, attribute
    QMenu *m_headerMenu;
};

#endif // JOURNALVIEWER_H
