#ifndef MACIPPACTIONS_H
#define MACIPPACTIONS_H

#include <QPointer>
#include <QList>
#include <QSet>
#include <QVariantMap>
#include <fly-admin-printer/connection.h>
#include "markervar.h"
#include "fly-admin-printer-mac_export.h"

class QWidget;

class FLY_ADMIN_PRINTER_MAC_EXPORT MacIppActions
{
public:

    struct Info
    {
        QList<MarkerVar> markerVars;
        bool journal = false;
        QString defaultFont;
        QStringList fonts;
        QSet<ipp_op_t> allowedRequests;
        int sessionId = -1;
        int jobId = -1;
        QString printerUri;
    };

    bool setPrinterMac(const QString &uri, const QString &min, const QString &max);
    bool setPrinterPolicy(const QString &uri, const QString &policy);
    Info getMacInfo(int jobid) const;
    bool checkMarking(int jobid) const;
    bool lockJob(int jobid);
    bool unlockJob(int jobid);
    bool setJobAttributes(int jobid, const QMap<QString, QString> &attributes, int sessionId = -1) const;
    QList<int> markJob(int jobid, const QMap<QString, QString> &attributes) const;
    bool getJournal(const QMap<QString, QString> &attributes, QList<QVariantMap> *journal) const;
    bool setJobMacAttrs(const QString &dest, int id, const QMap<QString, QString> &attrs);

    static MacIppActions *instance();

private:
    MacIppActions() {}
    ~MacIppActions() {}

    static void destroy();

    struct JobData
    {
        int id = -1;
        int copies = -1;
        int sessionId = -1;
        QString name;
        QStringList requestedAttributes;
        QMap<QString, QString> attributes;
    };

    QList<QVariantMap> doRequest(Cups::Connection *connection, ipp_op_t op, const JobData &job, bool *ok) const;
    static MacIppActions *m_instance;
};

#endif // MACIPPACTIONS_H
