#ifndef MARKERVAR_H
#define MARKERVAR_H

#include <QString>
#include <QList>
#include <QStringList>
#include <QIODevice>
#include "fly-admin-printer-mac_export.h"

class FLY_ADMIN_PRINTER_MAC_EXPORT MarkerVar
{
public:
    MarkerVar();

    enum Type
    {
        Hidden = 0,
        Regular,
        Optional
    };

    QString attribute;
    QString title;
    QString defaultValue;
    Type type = Hidden;

    static QList<MarkerVar> deserialize(const QStringList &markers);
    static QList<MarkerVar> deserialize(QIODevice *input);
    static void serialize(const QList<MarkerVar> &markers, QIODevice *output);

private:
    static QStringList splitLine(const QString &line);
    static QString escaped(const QString &value);
};

#endif // MARKERVAR_H
